-------------------------------------------------------------------------------
-- user_io_board_controller_slot1_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library user_io_board_controller_plbw_v1_01_a;
use user_io_board_controller_plbw_v1_01_a.all;

entity user_io_board_controller_slot1_wrapper is
  port (
    buttons_big : in std_logic_vector(0 to 1);
    buttons_small : in std_logic_vector(0 to 5);
    splb_clk : in std_logic;
    dip_switch : in std_logic_vector(0 to 3);
    plb_abus : in std_logic_vector(0 to 31);
    plb_pavalid : in std_logic;
    plb_rnw : in std_logic;
    plb_wrdbus : in std_logic_vector(0 to 63);
    reset : in std_logic;
    splb_rst : in std_logic;
    trackball_ox : in std_logic;
    trackball_oxn : in std_logic;
    trackball_oy : in std_logic;
    trackball_oyn : in std_logic;
    trackball_sel2 : in std_logic;
    buzzer : out std_logic;
    cs : out std_logic;
    leds : out std_logic_vector(0 to 7);
    resetlcd : out std_logic;
    scl : out std_logic;
    sdi : out std_logic;
    sl_addrack : out std_logic;
    sl_rdcomp : out std_logic;
    sl_rddack : out std_logic;
    sl_rddbus : out std_logic_vector(0 to 63);
    sl_wait : out std_logic;
    sl_wrcomp : out std_logic;
    sl_wrdack : out std_logic;
    trackball_sel1 : out std_logic;
    trackball_xscn : out std_logic;
    trackball_yscn : out std_logic
  );

  attribute x_core_info : STRING;
  attribute x_core_info of user_io_board_controller_slot1_wrapper : entity is "user_io_board_controller_plbw_v1_01_a";

end user_io_board_controller_slot1_wrapper;

architecture STRUCTURE of user_io_board_controller_slot1_wrapper is

  component user_io_board_controller_plbw is
    generic (
      C_BASEADDR : std_logic_vector(0 to 31);
      C_HIGHADDR : std_logic_vector(0 to 31);
      C_SPLB_AWIDTH : INTEGER;
      C_SPLB_DWIDTH : INTEGER;
      C_SPLB_P2P : INTEGER;
      C_SPLB_MID_WIDTH : INTEGER;
      C_SPLB_NUM_MASTERS : INTEGER;
      C_SPLB_SUPPORT_BURSTS : INTEGER;
      C_SPLB_NATIVE_DWIDTH : INTEGER;
      C_MEMMAP_BUTTONS_BIG : integer;
      C_MEMMAP_BUTTONS_BIG_N_BITS : integer;
      C_MEMMAP_BUTTONS_BIG_BIN_PT : integer;
      C_MEMMAP_BUTTONS_SMALL : integer;
      C_MEMMAP_BUTTONS_SMALL_N_BITS : integer;
      C_MEMMAP_BUTTONS_SMALL_BIN_PT : integer;
      C_MEMMAP_DIP_SWITCH : integer;
      C_MEMMAP_DIP_SWITCH_N_BITS : integer;
      C_MEMMAP_DIP_SWITCH_BIN_PT : integer;
      C_MEMMAP_TRACKBALL : integer;
      C_MEMMAP_TRACKBALL_N_BITS : integer;
      C_MEMMAP_TRACKBALL_BIN_PT : integer;
      C_MEMMAP_BUZZER_DUTYCYCLE : integer;
      C_MEMMAP_BUZZER_DUTYCYCLE_N_BITS : integer;
      C_MEMMAP_BUZZER_DUTYCYCLE_BIN_PT : integer;
      C_MEMMAP_BUZZER_ENABLE : integer;
      C_MEMMAP_BUZZER_ENABLE_N_BITS : integer;
      C_MEMMAP_BUZZER_ENABLE_BIN_PT : integer;
      C_MEMMAP_BUZZER_PERIOD : integer;
      C_MEMMAP_BUZZER_PERIOD_N_BITS : integer;
      C_MEMMAP_BUZZER_PERIOD_BIN_PT : integer;
      C_MEMMAP_LCD_BACKGROUNDCOLOR : integer;
      C_MEMMAP_LCD_BACKGROUNDCOLOR_N_BITS : integer;
      C_MEMMAP_LCD_BACKGROUNDCOLOR_BIN_PT : integer;
      C_MEMMAP_LCD_CHARACTEROFFSET : integer;
      C_MEMMAP_LCD_CHARACTEROFFSET_N_BITS : integer;
      C_MEMMAP_LCD_CHARACTEROFFSET_BIN_PT : integer;
      C_MEMMAP_LCD_CHARACTERSSELECT : integer;
      C_MEMMAP_LCD_CHARACTERSSELECT_N_BITS : integer;
      C_MEMMAP_LCD_CHARACTERSSELECT_BIN_PT : integer;
      C_MEMMAP_LCD_COLSET : integer;
      C_MEMMAP_LCD_COLSET_N_BITS : integer;
      C_MEMMAP_LCD_COLSET_BIN_PT : integer;
      C_MEMMAP_LCD_CONFIGLOCATION : integer;
      C_MEMMAP_LCD_CONFIGLOCATION_N_BITS : integer;
      C_MEMMAP_LCD_CONFIGLOCATION_BIN_PT : integer;
      C_MEMMAP_LCD_DIVIDERSELECT : integer;
      C_MEMMAP_LCD_DIVIDERSELECT_N_BITS : integer;
      C_MEMMAP_LCD_DIVIDERSELECT_BIN_PT : integer;
      C_MEMMAP_LCD_FIRSTEND : integer;
      C_MEMMAP_LCD_FIRSTEND_N_BITS : integer;
      C_MEMMAP_LCD_FIRSTEND_BIN_PT : integer;
      C_MEMMAP_LCD_FIRSTSTART : integer;
      C_MEMMAP_LCD_FIRSTSTART_N_BITS : integer;
      C_MEMMAP_LCD_FIRSTSTART_BIN_PT : integer;
      C_MEMMAP_LCD_LINEOFFSET : integer;
      C_MEMMAP_LCD_LINEOFFSET_N_BITS : integer;
      C_MEMMAP_LCD_LINEOFFSET_BIN_PT : integer;
      C_MEMMAP_LCD_RAMWRITE : integer;
      C_MEMMAP_LCD_RAMWRITE_N_BITS : integer;
      C_MEMMAP_LCD_RAMWRITE_BIN_PT : integer;
      C_MEMMAP_LCD_RESET : integer;
      C_MEMMAP_LCD_RESET_N_BITS : integer;
      C_MEMMAP_LCD_RESET_BIN_PT : integer;
      C_MEMMAP_LCD_RESETLCD : integer;
      C_MEMMAP_LCD_RESETLCD_N_BITS : integer;
      C_MEMMAP_LCD_RESETLCD_BIN_PT : integer;
      C_MEMMAP_LCD_ROWSET : integer;
      C_MEMMAP_LCD_ROWSET_N_BITS : integer;
      C_MEMMAP_LCD_ROWSET_BIN_PT : integer;
      C_MEMMAP_LCD_SECONDEND : integer;
      C_MEMMAP_LCD_SECONDEND_N_BITS : integer;
      C_MEMMAP_LCD_SECONDEND_BIN_PT : integer;
      C_MEMMAP_LCD_SECONDSTART : integer;
      C_MEMMAP_LCD_SECONDSTART_N_BITS : integer;
      C_MEMMAP_LCD_SECONDSTART_BIN_PT : integer;
      C_MEMMAP_LCD_SEND : integer;
      C_MEMMAP_LCD_SEND_N_BITS : integer;
      C_MEMMAP_LCD_SEND_BIN_PT : integer;
      C_MEMMAP_LCD_TOTALCMDTRANSFER : integer;
      C_MEMMAP_LCD_TOTALCMDTRANSFER_N_BITS : integer;
      C_MEMMAP_LCD_TOTALCMDTRANSFER_BIN_PT : integer;
      C_MEMMAP_LEDS : integer;
      C_MEMMAP_LEDS_N_BITS : integer;
      C_MEMMAP_LEDS_BIN_PT : integer;
      C_MEMMAP_LCD_CHARACTERMAP : integer;
      C_MEMMAP_LCD_CHARACTERMAP_N_BITS : integer;
      C_MEMMAP_LCD_CHARACTERMAP_BIN_PT : integer;
      C_MEMMAP_LCD_CHARACTERS : integer;
      C_MEMMAP_LCD_CHARACTERS_N_BITS : integer;
      C_MEMMAP_LCD_CHARACTERS_BIN_PT : integer;
      C_MEMMAP_LCD_COMMANDS : integer;
      C_MEMMAP_LCD_COMMANDS_N_BITS : integer;
      C_MEMMAP_LCD_COMMANDS_BIN_PT : integer
    );
    port (
      buttons_big : in std_logic_vector(0 to (2-1));
      buttons_small : in std_logic_vector(0 to (6-1));
      splb_clk : in std_logic;
      dip_switch : in std_logic_vector(0 to (4-1));
      plb_abus : in std_logic_vector(0 to (32-1));
      plb_pavalid : in std_logic;
      plb_rnw : in std_logic;
      plb_wrdbus : in std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      reset : in std_logic;
      splb_rst : in std_logic;
      trackball_ox : in std_logic;
      trackball_oxn : in std_logic;
      trackball_oy : in std_logic;
      trackball_oyn : in std_logic;
      trackball_sel2 : in std_logic;
      buzzer : out std_logic;
      cs : out std_logic;
      leds : out std_logic_vector(0 to (8-1));
      resetlcd : out std_logic;
      scl : out std_logic;
      sdi : out std_logic;
      sl_addrack : out std_logic;
      sl_rdcomp : out std_logic;
      sl_rddack : out std_logic;
      sl_rddbus : out std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      sl_wait : out std_logic;
      sl_wrcomp : out std_logic;
      sl_wrdack : out std_logic;
      trackball_sel1 : out std_logic;
      trackball_xscn : out std_logic;
      trackball_yscn : out std_logic
    );
  end component;

begin

  user_io_board_controller_slot1 : user_io_board_controller_plbw
    generic map (
      C_BASEADDR => X"84120000",
      C_HIGHADDR => X"8413ffff",
      C_SPLB_AWIDTH => 32,
      C_SPLB_DWIDTH => 64,
      C_SPLB_P2P => 0,
      C_SPLB_MID_WIDTH => 1,
      C_SPLB_NUM_MASTERS => 2,
      C_SPLB_SUPPORT_BURSTS => 0,
      C_SPLB_NATIVE_DWIDTH => 32,
      C_MEMMAP_BUTTONS_BIG => 16#10054#,
      C_MEMMAP_BUTTONS_BIG_N_BITS => 2,
      C_MEMMAP_BUTTONS_BIG_BIN_PT => 0,
      C_MEMMAP_BUTTONS_SMALL => 16#10058#,
      C_MEMMAP_BUTTONS_SMALL_N_BITS => 6,
      C_MEMMAP_BUTTONS_SMALL_BIN_PT => 0,
      C_MEMMAP_DIP_SWITCH => 16#1005C#,
      C_MEMMAP_DIP_SWITCH_N_BITS => 4,
      C_MEMMAP_DIP_SWITCH_BIN_PT => 0,
      C_MEMMAP_TRACKBALL => 16#10060#,
      C_MEMMAP_TRACKBALL_N_BITS => 5,
      C_MEMMAP_TRACKBALL_BIN_PT => 0,
      C_MEMMAP_BUZZER_DUTYCYCLE => 16#10000#,
      C_MEMMAP_BUZZER_DUTYCYCLE_N_BITS => 18,
      C_MEMMAP_BUZZER_DUTYCYCLE_BIN_PT => 18,
      C_MEMMAP_BUZZER_ENABLE => 16#10004#,
      C_MEMMAP_BUZZER_ENABLE_N_BITS => 1,
      C_MEMMAP_BUZZER_ENABLE_BIN_PT => 0,
      C_MEMMAP_BUZZER_PERIOD => 16#10008#,
      C_MEMMAP_BUZZER_PERIOD_N_BITS => 18,
      C_MEMMAP_BUZZER_PERIOD_BIN_PT => 0,
      C_MEMMAP_LCD_BACKGROUNDCOLOR => 16#1000C#,
      C_MEMMAP_LCD_BACKGROUNDCOLOR_N_BITS => 9,
      C_MEMMAP_LCD_BACKGROUNDCOLOR_BIN_PT => 0,
      C_MEMMAP_LCD_CHARACTEROFFSET => 16#10010#,
      C_MEMMAP_LCD_CHARACTEROFFSET_N_BITS => 4,
      C_MEMMAP_LCD_CHARACTEROFFSET_BIN_PT => 0,
      C_MEMMAP_LCD_CHARACTERSSELECT => 16#10014#,
      C_MEMMAP_LCD_CHARACTERSSELECT_N_BITS => 3,
      C_MEMMAP_LCD_CHARACTERSSELECT_BIN_PT => 0,
      C_MEMMAP_LCD_COLSET => 16#10018#,
      C_MEMMAP_LCD_COLSET_N_BITS => 9,
      C_MEMMAP_LCD_COLSET_BIN_PT => 0,
      C_MEMMAP_LCD_CONFIGLOCATION => 16#1001C#,
      C_MEMMAP_LCD_CONFIGLOCATION_N_BITS => 2,
      C_MEMMAP_LCD_CONFIGLOCATION_BIN_PT => 0,
      C_MEMMAP_LCD_DIVIDERSELECT => 16#10020#,
      C_MEMMAP_LCD_DIVIDERSELECT_N_BITS => 1,
      C_MEMMAP_LCD_DIVIDERSELECT_BIN_PT => 0,
      C_MEMMAP_LCD_FIRSTEND => 16#10024#,
      C_MEMMAP_LCD_FIRSTEND_N_BITS => 9,
      C_MEMMAP_LCD_FIRSTEND_BIN_PT => 0,
      C_MEMMAP_LCD_FIRSTSTART => 16#10028#,
      C_MEMMAP_LCD_FIRSTSTART_N_BITS => 9,
      C_MEMMAP_LCD_FIRSTSTART_BIN_PT => 0,
      C_MEMMAP_LCD_LINEOFFSET => 16#1002C#,
      C_MEMMAP_LCD_LINEOFFSET_N_BITS => 4,
      C_MEMMAP_LCD_LINEOFFSET_BIN_PT => 0,
      C_MEMMAP_LCD_RAMWRITE => 16#10030#,
      C_MEMMAP_LCD_RAMWRITE_N_BITS => 9,
      C_MEMMAP_LCD_RAMWRITE_BIN_PT => 0,
      C_MEMMAP_LCD_RESET => 16#10034#,
      C_MEMMAP_LCD_RESET_N_BITS => 1,
      C_MEMMAP_LCD_RESET_BIN_PT => 0,
      C_MEMMAP_LCD_RESETLCD => 16#10038#,
      C_MEMMAP_LCD_RESETLCD_N_BITS => 1,
      C_MEMMAP_LCD_RESETLCD_BIN_PT => 0,
      C_MEMMAP_LCD_ROWSET => 16#1003C#,
      C_MEMMAP_LCD_ROWSET_N_BITS => 9,
      C_MEMMAP_LCD_ROWSET_BIN_PT => 0,
      C_MEMMAP_LCD_SECONDEND => 16#10040#,
      C_MEMMAP_LCD_SECONDEND_N_BITS => 9,
      C_MEMMAP_LCD_SECONDEND_BIN_PT => 0,
      C_MEMMAP_LCD_SECONDSTART => 16#10044#,
      C_MEMMAP_LCD_SECONDSTART_N_BITS => 9,
      C_MEMMAP_LCD_SECONDSTART_BIN_PT => 0,
      C_MEMMAP_LCD_SEND => 16#10048#,
      C_MEMMAP_LCD_SEND_N_BITS => 1,
      C_MEMMAP_LCD_SEND_BIN_PT => 0,
      C_MEMMAP_LCD_TOTALCMDTRANSFER => 16#1004C#,
      C_MEMMAP_LCD_TOTALCMDTRANSFER_N_BITS => 8,
      C_MEMMAP_LCD_TOTALCMDTRANSFER_BIN_PT => 0,
      C_MEMMAP_LEDS => 16#10050#,
      C_MEMMAP_LEDS_N_BITS => 8,
      C_MEMMAP_LEDS_BIN_PT => 0,
      C_MEMMAP_LCD_CHARACTERMAP => 16#00000#,
      C_MEMMAP_LCD_CHARACTERMAP_N_BITS => 32,
      C_MEMMAP_LCD_CHARACTERMAP_BIN_PT => 0,
      C_MEMMAP_LCD_CHARACTERS => 16#04000#,
      C_MEMMAP_LCD_CHARACTERS_N_BITS => 32,
      C_MEMMAP_LCD_CHARACTERS_BIN_PT => 0,
      C_MEMMAP_LCD_COMMANDS => 16#04800#,
      C_MEMMAP_LCD_COMMANDS_N_BITS => 32,
      C_MEMMAP_LCD_COMMANDS_BIN_PT => 0
    )
    port map (
      buttons_big => buttons_big,
      buttons_small => buttons_small,
      splb_clk => splb_clk,
      dip_switch => dip_switch,
      plb_abus => plb_abus,
      plb_pavalid => plb_pavalid,
      plb_rnw => plb_rnw,
      plb_wrdbus => plb_wrdbus,
      reset => reset,
      splb_rst => splb_rst,
      trackball_ox => trackball_ox,
      trackball_oxn => trackball_oxn,
      trackball_oy => trackball_oy,
      trackball_oyn => trackball_oyn,
      trackball_sel2 => trackball_sel2,
      buzzer => buzzer,
      cs => cs,
      leds => leds,
      resetlcd => resetlcd,
      scl => scl,
      sdi => sdi,
      sl_addrack => sl_addrack,
      sl_rdcomp => sl_rdcomp,
      sl_rddack => sl_rddack,
      sl_rddbus => sl_rddbus,
      sl_wait => sl_wait,
      sl_wrcomp => sl_wrcomp,
      sl_wrdack => sl_wrdack,
      trackball_sel1 => trackball_sel1,
      trackball_xscn => trackball_xscn,
      trackball_yscn => trackball_yscn
    );

end architecture STRUCTURE;

