-------------------------------------------------------------------------------
-- warplab_mimo_4x4_agc_plbw_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library warplab_mimo_4x4_agc_plbw_v2_00_a;
use warplab_mimo_4x4_agc_plbw_v2_00_a.all;

entity warplab_mimo_4x4_agc_plbw_0_wrapper is
  port (
    sysgen_clk : in std_logic;
    i_in_a : in std_logic_vector(0 to 13);
    i_in_b : in std_logic_vector(0 to 13);
    i_in_c : in std_logic_vector(0 to 13);
    i_in_d : in std_logic_vector(0 to 13);
    mreset_in : in std_logic;
    packet_in : in std_logic;
    plb_abus : in std_logic_vector(0 to 31);
    plb_pavalid : in std_logic;
    plb_rnw : in std_logic;
    plb_wrdbus : in std_logic_vector(0 to 31);
    q_in_a : in std_logic_vector(0 to 13);
    q_in_b : in std_logic_vector(0 to 13);
    q_in_c : in std_logic_vector(0 to 13);
    q_in_d : in std_logic_vector(0 to 13);
    reset_in : in std_logic;
    rssi_in_a : in std_logic_vector(0 to 9);
    rssi_in_b : in std_logic_vector(0 to 9);
    rssi_in_c : in std_logic_vector(0 to 9);
    rssi_in_d : in std_logic_vector(0 to 9);
    splb_rst : in std_logic;
    splb_clk : in std_logic;
    agc_done : out std_logic;
    debug_agc : out std_logic;
    debug_agc_rst : out std_logic;
    debug_agc_rstfbk : out std_logic;
    debug_pktin : out std_logic;
    done_a : out std_logic;
    done_b : out std_logic;
    done_c : out std_logic;
    done_d : out std_logic;
    g_bb_a : out std_logic_vector(0 to 4);
    g_bb_b : out std_logic_vector(0 to 4);
    g_bb_c : out std_logic_vector(0 to 4);
    g_bb_d : out std_logic_vector(0 to 4);
    g_rf_a : out std_logic_vector(0 to 1);
    g_rf_b : out std_logic_vector(0 to 1);
    g_rf_c : out std_logic_vector(0 to 1);
    g_rf_d : out std_logic_vector(0 to 1);
    i_out_a : out std_logic_vector(0 to 13);
    i_out_b : out std_logic_vector(0 to 13);
    i_out_c : out std_logic_vector(0 to 13);
    i_out_d : out std_logic_vector(0 to 13);
    q_out_a : out std_logic_vector(0 to 13);
    q_out_b : out std_logic_vector(0 to 13);
    q_out_c : out std_logic_vector(0 to 13);
    q_out_d : out std_logic_vector(0 to 13);
    rxhp_a : out std_logic;
    rxhp_b : out std_logic;
    rxhp_c : out std_logic;
    rxhp_d : out std_logic;
    sl_addrack : out std_logic;
    sl_rdcomp : out std_logic;
    sl_rddack : out std_logic;
    sl_rddbus : out std_logic_vector(0 to 31);
    sl_wait : out std_logic;
    sl_wrcomp : out std_logic;
    sl_wrdack : out std_logic
  );

  attribute x_core_info : STRING;
  attribute x_core_info of warplab_mimo_4x4_agc_plbw_0_wrapper : entity is "warplab_mimo_4x4_agc_plbw_v2_00_a";

end warplab_mimo_4x4_agc_plbw_0_wrapper;

architecture STRUCTURE of warplab_mimo_4x4_agc_plbw_0_wrapper is

  component warplab_mimo_4x4_agc_plbw is
    generic (
      C_BASEADDR : std_logic_vector(0 to 31);
      C_HIGHADDR : std_logic_vector(0 to 31);
      C_SPLB_AWIDTH : INTEGER;
      C_SPLB_DWIDTH : INTEGER;
      C_SPLB_P2P : INTEGER;
      C_SPLB_MID_WIDTH : INTEGER;
      C_SPLB_NUM_MASTERS : INTEGER;
      C_SPLB_SUPPORT_BURSTS : INTEGER;
      C_SPLB_NATIVE_DWIDTH : INTEGER;
      C_MEMMAP_GBB_A : integer;
      C_MEMMAP_GBB_A_N_BITS : integer;
      C_MEMMAP_GBB_A_BIN_PT : integer;
      C_MEMMAP_GBB_B : integer;
      C_MEMMAP_GBB_B_N_BITS : integer;
      C_MEMMAP_GBB_B_BIN_PT : integer;
      C_MEMMAP_GBB_C : integer;
      C_MEMMAP_GBB_C_N_BITS : integer;
      C_MEMMAP_GBB_C_BIN_PT : integer;
      C_MEMMAP_GBB_D : integer;
      C_MEMMAP_GBB_D_N_BITS : integer;
      C_MEMMAP_GBB_D_BIN_PT : integer;
      C_MEMMAP_GRF_A : integer;
      C_MEMMAP_GRF_A_N_BITS : integer;
      C_MEMMAP_GRF_A_BIN_PT : integer;
      C_MEMMAP_GRF_B : integer;
      C_MEMMAP_GRF_B_N_BITS : integer;
      C_MEMMAP_GRF_B_BIN_PT : integer;
      C_MEMMAP_GRF_C : integer;
      C_MEMMAP_GRF_C_N_BITS : integer;
      C_MEMMAP_GRF_C_BIN_PT : integer;
      C_MEMMAP_GRF_D : integer;
      C_MEMMAP_GRF_D_N_BITS : integer;
      C_MEMMAP_GRF_D_BIN_PT : integer;
      C_MEMMAP_ADJ : integer;
      C_MEMMAP_ADJ_N_BITS : integer;
      C_MEMMAP_ADJ_BIN_PT : integer;
      C_MEMMAP_AGC_EN : integer;
      C_MEMMAP_AGC_EN_N_BITS : integer;
      C_MEMMAP_AGC_EN_BIN_PT : integer;
      C_MEMMAP_AGC_TRIGGER_DELAY : integer;
      C_MEMMAP_AGC_TRIGGER_DELAY_N_BITS : integer;
      C_MEMMAP_AGC_TRIGGER_DELAY_BIN_PT : integer;
      C_MEMMAP_AVG_LEN : integer;
      C_MEMMAP_AVG_LEN_N_BITS : integer;
      C_MEMMAP_AVG_LEN_BIN_PT : integer;
      C_MEMMAP_BITS : integer;
      C_MEMMAP_BITS_N_BITS : integer;
      C_MEMMAP_BITS_BIN_PT : integer;
      C_MEMMAP_DCO_TIMING : integer;
      C_MEMMAP_DCO_TIMING_N_BITS : integer;
      C_MEMMAP_DCO_TIMING_BIN_PT : integer;
      C_MEMMAP_GBB_INIT : integer;
      C_MEMMAP_GBB_INIT_N_BITS : integer;
      C_MEMMAP_GBB_INIT_BIN_PT : integer;
      C_MEMMAP_MRESET_IN : integer;
      C_MEMMAP_MRESET_IN_N_BITS : integer;
      C_MEMMAP_MRESET_IN_BIN_PT : integer;
      C_MEMMAP_PACKET_IN : integer;
      C_MEMMAP_PACKET_IN_N_BITS : integer;
      C_MEMMAP_PACKET_IN_BIN_PT : integer;
      C_MEMMAP_RADIO1_AGC_EN : integer;
      C_MEMMAP_RADIO1_AGC_EN_N_BITS : integer;
      C_MEMMAP_RADIO1_AGC_EN_BIN_PT : integer;
      C_MEMMAP_RADIO2_AGC_EN : integer;
      C_MEMMAP_RADIO2_AGC_EN_N_BITS : integer;
      C_MEMMAP_RADIO2_AGC_EN_BIN_PT : integer;
      C_MEMMAP_RADIO3_AGC_EN : integer;
      C_MEMMAP_RADIO3_AGC_EN_N_BITS : integer;
      C_MEMMAP_RADIO3_AGC_EN_BIN_PT : integer;
      C_MEMMAP_RADIO4_AGC_EN : integer;
      C_MEMMAP_RADIO4_AGC_EN_N_BITS : integer;
      C_MEMMAP_RADIO4_AGC_EN_BIN_PT : integer;
      C_MEMMAP_SRESET_IN : integer;
      C_MEMMAP_SRESET_IN_N_BITS : integer;
      C_MEMMAP_SRESET_IN_BIN_PT : integer;
      C_MEMMAP_T_DB : integer;
      C_MEMMAP_T_DB_N_BITS : integer;
      C_MEMMAP_T_DB_BIN_PT : integer;
      C_MEMMAP_THRESHOLDS : integer;
      C_MEMMAP_THRESHOLDS_N_BITS : integer;
      C_MEMMAP_THRESHOLDS_BIN_PT : integer;
      C_MEMMAP_TIMING : integer;
      C_MEMMAP_TIMING_N_BITS : integer;
      C_MEMMAP_TIMING_BIN_PT : integer
    );
    port (
      sysgen_clk : in std_logic;
      i_in_a : in std_logic_vector(0 to (14-1));
      i_in_b : in std_logic_vector(0 to (14-1));
      i_in_c : in std_logic_vector(0 to (14-1));
      i_in_d : in std_logic_vector(0 to (14-1));
      mreset_in : in std_logic;
      packet_in : in std_logic;
      plb_abus : in std_logic_vector(0 to (32-1));
      plb_pavalid : in std_logic;
      plb_rnw : in std_logic;
      plb_wrdbus : in std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      q_in_a : in std_logic_vector(0 to (14-1));
      q_in_b : in std_logic_vector(0 to (14-1));
      q_in_c : in std_logic_vector(0 to (14-1));
      q_in_d : in std_logic_vector(0 to (14-1));
      reset_in : in std_logic;
      rssi_in_a : in std_logic_vector(0 to (10-1));
      rssi_in_b : in std_logic_vector(0 to (10-1));
      rssi_in_c : in std_logic_vector(0 to (10-1));
      rssi_in_d : in std_logic_vector(0 to (10-1));
      splb_rst : in std_logic;
      splb_clk : in std_logic;
      agc_done : out std_logic;
      debug_agc : out std_logic;
      debug_agc_rst : out std_logic;
      debug_agc_rstfbk : out std_logic;
      debug_pktin : out std_logic;
      done_a : out std_logic;
      done_b : out std_logic;
      done_c : out std_logic;
      done_d : out std_logic;
      g_bb_a : out std_logic_vector(0 to (5-1));
      g_bb_b : out std_logic_vector(0 to (5-1));
      g_bb_c : out std_logic_vector(0 to (5-1));
      g_bb_d : out std_logic_vector(0 to (5-1));
      g_rf_a : out std_logic_vector(0 to (2-1));
      g_rf_b : out std_logic_vector(0 to (2-1));
      g_rf_c : out std_logic_vector(0 to (2-1));
      g_rf_d : out std_logic_vector(0 to (2-1));
      i_out_a : out std_logic_vector(0 to (14-1));
      i_out_b : out std_logic_vector(0 to (14-1));
      i_out_c : out std_logic_vector(0 to (14-1));
      i_out_d : out std_logic_vector(0 to (14-1));
      q_out_a : out std_logic_vector(0 to (14-1));
      q_out_b : out std_logic_vector(0 to (14-1));
      q_out_c : out std_logic_vector(0 to (14-1));
      q_out_d : out std_logic_vector(0 to (14-1));
      rxhp_a : out std_logic;
      rxhp_b : out std_logic;
      rxhp_c : out std_logic;
      rxhp_d : out std_logic;
      sl_addrack : out std_logic;
      sl_rdcomp : out std_logic;
      sl_rddack : out std_logic;
      sl_rddbus : out std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      sl_wait : out std_logic;
      sl_wrcomp : out std_logic;
      sl_wrdack : out std_logic
    );
  end component;

begin

  warplab_mimo_4x4_agc_plbw_0 : warplab_mimo_4x4_agc_plbw
    generic map (
      C_BASEADDR => X"c4a00000",
      C_HIGHADDR => X"c4a0ffff",
      C_SPLB_AWIDTH => 32,
      C_SPLB_DWIDTH => 32,
      C_SPLB_P2P => 0,
      C_SPLB_MID_WIDTH => 1,
      C_SPLB_NUM_MASTERS => 1,
      C_SPLB_SUPPORT_BURSTS => 0,
      C_SPLB_NATIVE_DWIDTH => 32,
      C_MEMMAP_GBB_A => 16#844#,
      C_MEMMAP_GBB_A_N_BITS => 5,
      C_MEMMAP_GBB_A_BIN_PT => 0,
      C_MEMMAP_GBB_B => 16#848#,
      C_MEMMAP_GBB_B_N_BITS => 5,
      C_MEMMAP_GBB_B_BIN_PT => 0,
      C_MEMMAP_GBB_C => 16#84C#,
      C_MEMMAP_GBB_C_N_BITS => 5,
      C_MEMMAP_GBB_C_BIN_PT => 0,
      C_MEMMAP_GBB_D => 16#850#,
      C_MEMMAP_GBB_D_N_BITS => 5,
      C_MEMMAP_GBB_D_BIN_PT => 0,
      C_MEMMAP_GRF_A => 16#854#,
      C_MEMMAP_GRF_A_N_BITS => 2,
      C_MEMMAP_GRF_A_BIN_PT => 0,
      C_MEMMAP_GRF_B => 16#858#,
      C_MEMMAP_GRF_B_N_BITS => 2,
      C_MEMMAP_GRF_B_BIN_PT => 0,
      C_MEMMAP_GRF_C => 16#85C#,
      C_MEMMAP_GRF_C_N_BITS => 2,
      C_MEMMAP_GRF_C_BIN_PT => 0,
      C_MEMMAP_GRF_D => 16#860#,
      C_MEMMAP_GRF_D_N_BITS => 2,
      C_MEMMAP_GRF_D_BIN_PT => 0,
      C_MEMMAP_ADJ => 16#800#,
      C_MEMMAP_ADJ_N_BITS => 16,
      C_MEMMAP_ADJ_BIN_PT => 0,
      C_MEMMAP_AGC_EN => 16#804#,
      C_MEMMAP_AGC_EN_N_BITS => 1,
      C_MEMMAP_AGC_EN_BIN_PT => 0,
      C_MEMMAP_AGC_TRIGGER_DELAY => 16#808#,
      C_MEMMAP_AGC_TRIGGER_DELAY_N_BITS => 9,
      C_MEMMAP_AGC_TRIGGER_DELAY_BIN_PT => 0,
      C_MEMMAP_AVG_LEN => 16#80C#,
      C_MEMMAP_AVG_LEN_N_BITS => 16,
      C_MEMMAP_AVG_LEN_BIN_PT => 0,
      C_MEMMAP_BITS => 16#810#,
      C_MEMMAP_BITS_N_BITS => 10,
      C_MEMMAP_BITS_BIN_PT => 0,
      C_MEMMAP_DCO_TIMING => 16#814#,
      C_MEMMAP_DCO_TIMING_N_BITS => 32,
      C_MEMMAP_DCO_TIMING_BIN_PT => 0,
      C_MEMMAP_GBB_INIT => 16#818#,
      C_MEMMAP_GBB_INIT_N_BITS => 16,
      C_MEMMAP_GBB_INIT_BIN_PT => 0,
      C_MEMMAP_MRESET_IN => 16#81C#,
      C_MEMMAP_MRESET_IN_N_BITS => 1,
      C_MEMMAP_MRESET_IN_BIN_PT => 0,
      C_MEMMAP_PACKET_IN => 16#820#,
      C_MEMMAP_PACKET_IN_N_BITS => 1,
      C_MEMMAP_PACKET_IN_BIN_PT => 0,
      C_MEMMAP_RADIO1_AGC_EN => 16#824#,
      C_MEMMAP_RADIO1_AGC_EN_N_BITS => 1,
      C_MEMMAP_RADIO1_AGC_EN_BIN_PT => 0,
      C_MEMMAP_RADIO2_AGC_EN => 16#828#,
      C_MEMMAP_RADIO2_AGC_EN_N_BITS => 1,
      C_MEMMAP_RADIO2_AGC_EN_BIN_PT => 0,
      C_MEMMAP_RADIO3_AGC_EN => 16#82C#,
      C_MEMMAP_RADIO3_AGC_EN_N_BITS => 1,
      C_MEMMAP_RADIO3_AGC_EN_BIN_PT => 0,
      C_MEMMAP_RADIO4_AGC_EN => 16#830#,
      C_MEMMAP_RADIO4_AGC_EN_N_BITS => 1,
      C_MEMMAP_RADIO4_AGC_EN_BIN_PT => 0,
      C_MEMMAP_SRESET_IN => 16#834#,
      C_MEMMAP_SRESET_IN_N_BITS => 1,
      C_MEMMAP_SRESET_IN_BIN_PT => 0,
      C_MEMMAP_T_DB => 16#838#,
      C_MEMMAP_T_DB_N_BITS => 16,
      C_MEMMAP_T_DB_BIN_PT => 0,
      C_MEMMAP_THRESHOLDS => 16#83C#,
      C_MEMMAP_THRESHOLDS_N_BITS => 32,
      C_MEMMAP_THRESHOLDS_BIN_PT => 0,
      C_MEMMAP_TIMING => 16#840#,
      C_MEMMAP_TIMING_N_BITS => 32,
      C_MEMMAP_TIMING_BIN_PT => 0
    )
    port map (
      sysgen_clk => sysgen_clk,
      i_in_a => i_in_a,
      i_in_b => i_in_b,
      i_in_c => i_in_c,
      i_in_d => i_in_d,
      mreset_in => mreset_in,
      packet_in => packet_in,
      plb_abus => plb_abus,
      plb_pavalid => plb_pavalid,
      plb_rnw => plb_rnw,
      plb_wrdbus => plb_wrdbus,
      q_in_a => q_in_a,
      q_in_b => q_in_b,
      q_in_c => q_in_c,
      q_in_d => q_in_d,
      reset_in => reset_in,
      rssi_in_a => rssi_in_a,
      rssi_in_b => rssi_in_b,
      rssi_in_c => rssi_in_c,
      rssi_in_d => rssi_in_d,
      splb_rst => splb_rst,
      splb_clk => splb_clk,
      agc_done => agc_done,
      debug_agc => debug_agc,
      debug_agc_rst => debug_agc_rst,
      debug_agc_rstfbk => debug_agc_rstfbk,
      debug_pktin => debug_pktin,
      done_a => done_a,
      done_b => done_b,
      done_c => done_c,
      done_d => done_d,
      g_bb_a => g_bb_a,
      g_bb_b => g_bb_b,
      g_bb_c => g_bb_c,
      g_bb_d => g_bb_d,
      g_rf_a => g_rf_a,
      g_rf_b => g_rf_b,
      g_rf_c => g_rf_c,
      g_rf_d => g_rf_d,
      i_out_a => i_out_a,
      i_out_b => i_out_b,
      i_out_c => i_out_c,
      i_out_d => i_out_d,
      q_out_a => q_out_a,
      q_out_b => q_out_b,
      q_out_c => q_out_c,
      q_out_d => q_out_d,
      rxhp_a => rxhp_a,
      rxhp_b => rxhp_b,
      rxhp_c => rxhp_c,
      rxhp_d => rxhp_d,
      sl_addrack => sl_addrack,
      sl_rdcomp => sl_rdcomp,
      sl_rddack => sl_rddack,
      sl_rddbus => sl_rddbus,
      sl_wait => sl_wait,
      sl_wrcomp => sl_wrcomp,
      sl_wrdack => sl_wrdack
    );

end architecture STRUCTURE;

